/*
 Do not modify, auto-generated by model_gen.tcl

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   attribute.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_ATTRIBUTE_H
#define UHDM_ATTRIBUTE_H

#include "SymbolFactory.h"
#include "BaseClass.h"
#include "containers.h"
#include "uhdm.h"

namespace UHDM {

  class attribute : public BaseClass {
  public:
    // Implicit constructor used to initialize all members,
    // comment: attribute();
    virtual ~attribute() final {}
    
    virtual const BaseClass* VpiParent() const final { return vpiParent_; }

    virtual bool VpiParent(BaseClass* data) final { vpiParent_ = data; if (data) uhdmParentType_ = data->UhdmType(); return true;}

    virtual unsigned int UhdmParentType() const final { return uhdmParentType_; }

    virtual bool UhdmParentType(unsigned int data) final { uhdmParentType_ = data; return true;}

    virtual bool VpiFile(const std::string& data) final;

    virtual const std::string& VpiFile() const final;

    virtual int VpiLineNo() const final { return vpiLineNo_; }

    virtual bool VpiLineNo(int data) final { vpiLineNo_ = data; return true;}

    unsigned int UhdmId() const { return uhdmId_; }

    bool UhdmId(unsigned int data) { uhdmId_ = data; return true;}

    attribute* DeepClone(Serializer* serializer, ElaboratorListener* elab_listener) const override;

    bool VpiName(const std::string& data);

    const std::string& VpiName() const;

    bool VpiDefAttribute() const { return vpiDefAttribute_; }

    bool VpiDefAttribute(bool data) { vpiDefAttribute_ = data; return true;}

    bool VpiValue(const std::string& data);

    const std::string& VpiValue() const;

    bool VpiDefFile(const std::string& data);

    const std::string& VpiDefFile() const;

    int VpiDefLineNo() const { return vpiDefLineNo_; }

    bool VpiDefLineNo(int data) { vpiDefLineNo_ = data; return true;}

    unsigned int VpiType() const final { return vpiAttribute; }

   virtual  UHDM_OBJECT_TYPE UhdmType() const final { return uhdmattribute; }   
  private:
    
    BaseClass* vpiParent_ = nullptr;

    unsigned int uhdmParentType_ = 0;

    SymbolFactory::ID vpiFile_ = 0;

    int vpiLineNo_ = 0;

    unsigned int uhdmId_ = 0;

    SymbolFactory::ID vpiName_ = 0;

    bool vpiDefAttribute_ = 0;

    SymbolFactory::ID vpiValue_ = 0;

    SymbolFactory::ID vpiDefFile_ = 0;

    int vpiDefLineNo_ = 0;

  };

  
  class attributeFactory {
  friend Serializer;
  public:
  attribute* Make() {
    attribute* obj = new attribute();
    objects_.push_back(obj);
    return obj;
  }
  private:
    std::vector<attribute*> objects_;
  };
  
  
  class VectorOfattributeFactory {
  friend Serializer;
  public:
  std::vector<attribute*>* Make() {
    std::vector<attribute*>* obj = new std::vector<attribute*>();
    objects_.push_back(obj);
    return obj;
  }
  private:
  std::vector<std::vector<attribute*>*> objects_;
  };

};

#endif
