/*
 Do not modify, auto-generated by model_gen.tcl

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   event_stmt.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_EVENT_STMT_H
#define UHDM_EVENT_STMT_H

#include "SymbolFactory.h"
#include "BaseClass.h"
#include "containers.h"
#include "uhdm.h"

namespace UHDM {

  class event_stmt : public atomic_stmt {
  public:
    // Implicit constructor used to initialize all members,
    // comment: event_stmt();
    virtual ~event_stmt() final {}
    
    virtual const BaseClass* VpiParent() const final { return vpiParent_; }

    virtual bool VpiParent(BaseClass* data) final { vpiParent_ = data; if (data) uhdmParentType_ = data->UhdmType(); return true;}

    virtual unsigned int UhdmParentType() const final { return uhdmParentType_; }

    virtual bool UhdmParentType(unsigned int data) final { uhdmParentType_ = data; return true;}

    virtual bool VpiFile(const std::string& data) final;

    virtual const std::string& VpiFile() const final;

    virtual int VpiLineNo() const final { return vpiLineNo_; }

    virtual bool VpiLineNo(int data) final { vpiLineNo_ = data; return true;}

    unsigned int UhdmId() const { return uhdmId_; }

    bool UhdmId(unsigned int data) { uhdmId_ = data; return true;}

    event_stmt* DeepClone(Serializer* serializer, ElaboratorListener* elab_listener) const override;

    bool VpiBlocking() const { return vpiBlocking_; }

    bool VpiBlocking(bool data) { vpiBlocking_ = data; return true;}

    const named_event* Named_event() const { return named_event_; }

    bool Named_event(named_event* data) { named_event_ = data; return true;}

    unsigned int VpiType() const final { return vpiEventStmt; }

   virtual  UHDM_OBJECT_TYPE UhdmType() const final { return uhdmevent_stmt; }   
  private:
    
    BaseClass* vpiParent_ = nullptr;

    unsigned int uhdmParentType_ = 0;

    SymbolFactory::ID vpiFile_ = 0;

    int vpiLineNo_ = 0;

    unsigned int uhdmId_ = 0;

    bool vpiBlocking_ = 0;

    named_event* named_event_ = nullptr;

  };

  
  class event_stmtFactory {
  friend Serializer;
  public:
  event_stmt* Make() {
    event_stmt* obj = new event_stmt();
    objects_.push_back(obj);
    return obj;
  }
  private:
    std::vector<event_stmt*> objects_;
  };
  
  
  class VectorOfevent_stmtFactory {
  friend Serializer;
  public:
  std::vector<event_stmt*>* Make() {
    std::vector<event_stmt*>* obj = new std::vector<event_stmt*>();
    objects_.push_back(obj);
    return obj;
  }
  private:
  std::vector<std::vector<event_stmt*>*> objects_;
  };

};

#endif
