/*
 Do not modify, auto-generated by model_gen.tcl

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   immediate_assume.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_IMMEDIATE_ASSUME_H
#define UHDM_IMMEDIATE_ASSUME_H

#include "SymbolFactory.h"
#include "BaseClass.h"
#include "containers.h"
#include "uhdm.h"

namespace UHDM {

  class immediate_assume : public assertion {
  public:
    // Implicit constructor used to initialize all members,
    // comment: immediate_assume();
    virtual ~immediate_assume() final {}
    
    virtual const BaseClass* VpiParent() const final { return vpiParent_; }

    virtual bool VpiParent(BaseClass* data) final { vpiParent_ = data; if (data) uhdmParentType_ = data->UhdmType(); return true;}

    virtual unsigned int UhdmParentType() const final { return uhdmParentType_; }

    virtual bool UhdmParentType(unsigned int data) final { uhdmParentType_ = data; return true;}

    virtual bool VpiFile(const std::string& data) final;

    virtual const std::string& VpiFile() const final;

    virtual int VpiLineNo() const final { return vpiLineNo_; }

    virtual bool VpiLineNo(int data) final { vpiLineNo_ = data; return true;}

    unsigned int UhdmId() const { return uhdmId_; }

    bool UhdmId(unsigned int data) { uhdmId_ = data; return true;}

    immediate_assume* DeepClone(Serializer* serializer, ElaboratorListener* elab_listener) const override;

    int VpiIsDeferred() const { return vpiIsDeferred_; }

    bool VpiIsDeferred(int data) { vpiIsDeferred_ = data; return true;}

    int VpiIsFinal() const { return vpiIsFinal_; }

    bool VpiIsFinal(int data) { vpiIsFinal_ = data; return true;}

    const expr* Expr() const { return expr_; }

    bool Expr(expr* data) { expr_ = data; return true;}

    const any* Stmt() const { return stmt_; }

    bool Stmt(any* data) {if (!stmtGroupCompliant(data)) return false; stmt_ = data; return true;}

    const any* Else_stmt() const { return else_stmt_; }

    bool Else_stmt(any* data) {if (!stmtGroupCompliant(data)) return false; else_stmt_ = data; return true;}

    unsigned int VpiType() const final { return vpiImmediateAssume; }

   virtual  UHDM_OBJECT_TYPE UhdmType() const final { return uhdmimmediate_assume; }   
  private:
    
    BaseClass* vpiParent_ = nullptr;

    unsigned int uhdmParentType_ = 0;

    SymbolFactory::ID vpiFile_ = 0;

    int vpiLineNo_ = 0;

    unsigned int uhdmId_ = 0;

    int vpiIsDeferred_ = 0;

    int vpiIsFinal_ = 0;

    expr* expr_ = nullptr;

    any* stmt_ = nullptr;

    any* else_stmt_ = nullptr;

  };

  
  class immediate_assumeFactory {
  friend Serializer;
  public:
  immediate_assume* Make() {
    immediate_assume* obj = new immediate_assume();
    objects_.push_back(obj);
    return obj;
  }
  private:
    std::vector<immediate_assume*> objects_;
  };
  
  
  class VectorOfimmediate_assumeFactory {
  friend Serializer;
  public:
  std::vector<immediate_assume*>* Make() {
    std::vector<immediate_assume*>* obj = new std::vector<immediate_assume*>();
    objects_.push_back(obj);
    return obj;
  }
  private:
  std::vector<std::vector<immediate_assume*>*> objects_;
  };

};

#endif
