/*
 Do not modify, auto-generated by model_gen.tcl

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   io_decl.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_IO_DECL_H
#define UHDM_IO_DECL_H

#include "SymbolFactory.h"
#include "BaseClass.h"
#include "containers.h"
#include "uhdm.h"

namespace UHDM {

  class io_decl : public BaseClass {
  public:
    // Implicit constructor used to initialize all members,
    // comment: io_decl();
    virtual ~io_decl() final {}
    
    virtual const BaseClass* VpiParent() const final { return vpiParent_; }

    virtual bool VpiParent(BaseClass* data) final { vpiParent_ = data; if (data) uhdmParentType_ = data->UhdmType(); return true;}

    virtual unsigned int UhdmParentType() const final { return uhdmParentType_; }

    virtual bool UhdmParentType(unsigned int data) final { uhdmParentType_ = data; return true;}

    virtual bool VpiFile(const std::string& data) final;

    virtual const std::string& VpiFile() const final;

    virtual int VpiLineNo() const final { return vpiLineNo_; }

    virtual bool VpiLineNo(int data) final { vpiLineNo_ = data; return true;}

    unsigned int UhdmId() const { return uhdmId_; }

    bool UhdmId(unsigned int data) { uhdmId_ = data; return true;}

    io_decl* DeepClone(Serializer* serializer, ElaboratorListener* elab_listener) const override;

    unsigned int VpiType() const final { return vpiIODecl; }

    int VpiDirection() const { return vpiDirection_; }

    bool VpiDirection(int data) { vpiDirection_ = data; return true;}

    bool VpiName(const std::string& data);

    const std::string& VpiName() const;

    bool VpiScalar() const { return vpiScalar_; }

    bool VpiScalar(bool data) { vpiScalar_ = data; return true;}

    bool VpiSigned() const { return vpiSigned_; }

    bool VpiSigned(bool data) { vpiSigned_ = data; return true;}

    int VpiSize() const { return vpiSize_; }

    bool VpiSize(int data) { vpiSize_ = data; return true;}

    bool VpiVector() const { return vpiVector_; }

    bool VpiVector(bool data) { vpiVector_ = data; return true;}

    const expr* Left_expr() const { return left_expr_; }

    bool Left_expr(expr* data) { left_expr_ = data; return true;}

    const expr* Right_expr() const { return right_expr_; }

    bool Right_expr(expr* data) { right_expr_ = data; return true;}

    const typespec* Typespec() const { return typespec_; }

    bool Typespec(typespec* data) { typespec_ = data; return true;}

    const instance* Instance() const { return instance_; }

    bool Instance(instance* data) { instance_ = data; return true;}

    const task_func* Task_func() const { return task_func_; }

    bool Task_func(task_func* data) { task_func_ = data; return true;}

    VectorOfrange* Ranges() const { return ranges_; }

    bool Ranges(VectorOfrange* data) { ranges_ = data; return true;}

    const udp_defn* Udp_defn() const { return udp_defn_; }

    bool Udp_defn(udp_defn* data) { udp_defn_ = data; return true;}

    const module* Module() const { return module_; }

    bool Module(module* data) { module_ = data; return true;}

    const any* Expr() const { return expr_; }

    bool Expr(any* data) {if (!ref_obj_interf_net_var_groupGroupCompliant(data)) return false; expr_ = data; return true;}

   virtual  UHDM_OBJECT_TYPE UhdmType() const final { return uhdmio_decl; }   
  private:
    
    BaseClass* vpiParent_ = nullptr;

    unsigned int uhdmParentType_ = 0;

    SymbolFactory::ID vpiFile_ = 0;

    int vpiLineNo_ = 0;

    unsigned int uhdmId_ = 0;

    int vpiDirection_ = 0;

    SymbolFactory::ID vpiName_ = 0;

    bool vpiScalar_ = 0;

    bool vpiSigned_ = 0;

    int vpiSize_ = 0;

    bool vpiVector_ = 0;

    expr* left_expr_ = nullptr;

    expr* right_expr_ = nullptr;

    typespec* typespec_ = nullptr;

    instance* instance_ = nullptr;

    task_func* task_func_ = nullptr;

    VectorOfrange* ranges_ = nullptr;

    udp_defn* udp_defn_ = nullptr;

    module* module_ = nullptr;

    any* expr_ = nullptr;

  };

  
  class io_declFactory {
  friend Serializer;
  public:
  io_decl* Make() {
    io_decl* obj = new io_decl();
    objects_.push_back(obj);
    return obj;
  }
  private:
    std::vector<io_decl*> objects_;
  };
  
  
  class VectorOfio_declFactory {
  friend Serializer;
  public:
  std::vector<io_decl*>* Make() {
    std::vector<io_decl*>* obj = new std::vector<io_decl*>();
    objects_.push_back(obj);
    return obj;
  }
  private:
  std::vector<std::vector<io_decl*>*> objects_;
  };

};

#endif
