/*
 Do not modify, auto-generated by model_gen.tcl

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   named_event.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_NAMED_EVENT_H
#define UHDM_NAMED_EVENT_H

#include "SymbolFactory.h"
#include "BaseClass.h"
#include "containers.h"
#include "uhdm.h"

namespace UHDM {

  class named_event : public BaseClass {
  public:
    // Implicit constructor used to initialize all members,
    // comment: named_event();
    virtual ~named_event() final {}
    
    virtual const BaseClass* VpiParent() const final { return vpiParent_; }

    virtual bool VpiParent(BaseClass* data) final { vpiParent_ = data; if (data) uhdmParentType_ = data->UhdmType(); return true;}

    virtual unsigned int UhdmParentType() const final { return uhdmParentType_; }

    virtual bool UhdmParentType(unsigned int data) final { uhdmParentType_ = data; return true;}

    virtual bool VpiFile(const std::string& data) final;

    virtual const std::string& VpiFile() const final;

    virtual int VpiLineNo() const final { return vpiLineNo_; }

    virtual bool VpiLineNo(int data) final { vpiLineNo_ = data; return true;}

    unsigned int UhdmId() const { return uhdmId_; }

    bool UhdmId(unsigned int data) { uhdmId_ = data; return true;}

    named_event* DeepClone(Serializer* serializer, ElaboratorListener* elab_listener) const override;

    bool VpiArrayMember() const { return vpiArrayMember_; }

    bool VpiArrayMember(bool data) { vpiArrayMember_ = data; return true;}

    bool VpiName(const std::string& data);

    const std::string& VpiName() const;

    bool VpiFullName(const std::string& data);

    const std::string&  VpiFullName() const;

    bool VpiAutomatic() const { return vpiAutomatic_; }

    bool VpiAutomatic(bool data) { vpiAutomatic_ = data; return true;}

    int VpiAllocScheme() const { return vpiAllocScheme_; }

    bool VpiAllocScheme(int data) { vpiAllocScheme_ = data; return true;}

    const event_typespec* Event_typespec() const { return event_typespec_; }

    bool Event_typespec(event_typespec* data) { event_typespec_ = data; return true;}

    VectorOfattribute* Attributes() const { return attributes_; }

    bool Attributes(VectorOfattribute* data) { attributes_ = data; return true;}

    VectorOfthread_obj* Threads() const { return threads_; }

    bool Threads(VectorOfthread_obj* data) { threads_ = data; return true;}

    unsigned int VpiType() const final { return vpiNamedEvent; }

   virtual  UHDM_OBJECT_TYPE UhdmType() const final { return uhdmnamed_event; }   
  private:
    
    BaseClass* vpiParent_ = nullptr;

    unsigned int uhdmParentType_ = 0;

    SymbolFactory::ID vpiFile_ = 0;

    int vpiLineNo_ = 0;

    unsigned int uhdmId_ = 0;

    bool vpiArrayMember_ = 0;

    SymbolFactory::ID vpiName_ = 0;

    SymbolFactory::ID vpiFullName_ = 0;

    bool vpiAutomatic_ = 0;

    int vpiAllocScheme_ = 0;

    event_typespec* event_typespec_ = nullptr;

    VectorOfattribute* attributes_ = nullptr;

    VectorOfthread_obj* threads_ = nullptr;

  };

  
  class named_eventFactory {
  friend Serializer;
  public:
  named_event* Make() {
    named_event* obj = new named_event();
    objects_.push_back(obj);
    return obj;
  }
  private:
    std::vector<named_event*> objects_;
  };
  
  
  class VectorOfnamed_eventFactory {
  friend Serializer;
  public:
  std::vector<named_event*>* Make() {
    std::vector<named_event*>* obj = new std::vector<named_event*>();
    objects_.push_back(obj);
    return obj;
  }
  private:
  std::vector<std::vector<named_event*>*> objects_;
  };

};

#endif
