/*
 Do not modify, auto-generated by model_gen.tcl

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   type_parameter.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_TYPE_PARAMETER_H
#define UHDM_TYPE_PARAMETER_H

#include "SymbolFactory.h"
#include "BaseClass.h"
#include "containers.h"
#include "uhdm.h"

namespace UHDM {

  class type_parameter : public typespec {
  public:
    // Implicit constructor used to initialize all members,
    // comment: type_parameter();
    virtual ~type_parameter() final {}
    
    virtual const BaseClass* VpiParent() const final { return vpiParent_; }

    virtual bool VpiParent(BaseClass* data) final { vpiParent_ = data; if (data) uhdmParentType_ = data->UhdmType(); return true;}

    virtual unsigned int UhdmParentType() const final { return uhdmParentType_; }

    virtual bool UhdmParentType(unsigned int data) final { uhdmParentType_ = data; return true;}

    virtual bool VpiFile(const std::string& data) final;

    virtual const std::string& VpiFile() const final;

    virtual int VpiLineNo() const final { return vpiLineNo_; }

    virtual bool VpiLineNo(int data) final { vpiLineNo_ = data; return true;}

    unsigned int UhdmId() const { return uhdmId_; }

    bool UhdmId(unsigned int data) { uhdmId_ = data; return true;}

    type_parameter* DeepClone(Serializer* serializer, ElaboratorListener* elab_listener) const override;

    bool VpiLocalParam() const { return vpiLocalParam_; }

    bool VpiLocalParam(bool data) { vpiLocalParam_ = data; return true;}

    bool VpiFullName(const std::string& data);

    const std::string&  VpiFullName() const;

    const typespec* Typespec() const { return typespec_; }

    bool Typespec(typespec* data) { typespec_ = data; return true;}

    const typespec* Expr() const { return expr_; }

    bool Expr(typespec* data) { expr_ = data; return true;}

    unsigned int VpiType() const final { return vpiTypeParameter; }

   virtual  UHDM_OBJECT_TYPE UhdmType() const final { return uhdmtype_parameter; }   
  private:
    
    BaseClass* vpiParent_ = nullptr;

    unsigned int uhdmParentType_ = 0;

    SymbolFactory::ID vpiFile_ = 0;

    int vpiLineNo_ = 0;

    unsigned int uhdmId_ = 0;

    bool vpiLocalParam_ = 0;

    SymbolFactory::ID vpiFullName_ = 0;

    typespec* typespec_ = nullptr;

    typespec* expr_ = nullptr;

  };

  
  class type_parameterFactory {
  friend Serializer;
  public:
  type_parameter* Make() {
    type_parameter* obj = new type_parameter();
    objects_.push_back(obj);
    return obj;
  }
  private:
    std::vector<type_parameter*> objects_;
  };
  
  
  class VectorOftype_parameterFactory {
  friend Serializer;
  public:
  std::vector<type_parameter*>* Make() {
    std::vector<type_parameter*>* obj = new std::vector<type_parameter*>();
    objects_.push_back(obj);
    return obj;
  }
  private:
  std::vector<std::vector<type_parameter*>*> objects_;
  };

};

#endif
